/*
===== Programme Libre Chronos =====
 Conu par Elouan P.C. pour le CNRS
 => Exprience : Plus - Maze

 Librairie utilise : SDL
*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>

void convertir(char* chaine, const int temps);
int clavier(SDL_Event event, char *saisie, int max);

int main (int argc, char *argv[])
{
    // Initialisations des variables --
    FILE* config = NULL;
    config = fopen("config.ini", "r");
    int delais[2]= {0};

    if (config != NULL)
    {
        fscanf(config, "%d %d", &delais[0], &delais[1]);
        fclose(config);
    }
    else
    {
        delais[0] = 2; // Prcision relle --
        delais[1] = 10; // Dlai d'affichage
    }

    int minuteur = 5;

    SDL_Surface *ecran = NULL, *fond = NULL, *bouton = NULL, *saisie = NULL, *srat = NULL, *point = NULL, *sarat = NULL;
    SDL_Surface *Chrono[5] = {NULL}, *Passage[5] = {NULL}, *ChronoP = NULL;
    SDL_Rect positionFond, positionSarat, positionPassage[5], positionChrono[5], positionChronoP, positionSaisie, positionPoint[5];
    SDL_Event event;
    TTF_Font *police = NULL, *ppolice = NULL, *gpolice = NULL, *ggpolice = NULL;
    FILE* fichier = NULL;
    int continuer = 1, i = 0, p = 4, r = 1;
    int tempsPrecedent = 0, tempsActuel = 0;
    int passages[6] = {0}, centrage[5] = {0}, chronos[6] = {0}, decompte = minuteur * 60 * 1000, top = 0;

    char chronometre[100] = "", cpassage[100] = "", serie[100] = "";
    char rat[100] = "", arat[100] = "",chaine[100] = "";

    // Initialisation des systmes
    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
    TTF_Init();

    SDL_WM_SetIcon(IMG_Load("icone.png"), NULL);

    ecran = SDL_SetVideoMode(400, 200, 32, SDL_HWSURFACE| SDL_DOUBLEBUF);
    SDL_WM_SetCaption("Aurora", NULL);

    police = TTF_OpenFont("police.ttf", 16);
    TTF_SetFontStyle(police, TTF_STYLE_BOLD);

    gpolice = TTF_OpenFont("police.ttf", 18);
    TTF_SetFontStyle(gpolice, TTF_STYLE_BOLD);

    ppolice = TTF_OpenFont("police.ttf", 15);
    TTF_SetFontStyle(ppolice, TTF_STYLE_BOLD);

    ggpolice = TTF_OpenFont("police.ttf", 28);
    TTF_SetFontStyle(ggpolice, TTF_STYLE_BOLD);

    SDL_Color noir = { 0, 0, 0};

    fond = SDL_LoadBMP("saisie.bmp");

    positionFond.x = 0;
    positionFond.y = 0;

    positionSaisie.x = 80;
    positionSaisie.y = 225;

    SDL_BlitSurface(fond, NULL, ecran, &positionFond);
    SDL_Flip(ecran);

    while (continuer)
    {
        SDL_WaitEvent(&event);
        continuer = clavier(event, serie, 17);

        SDL_BlitSurface(fond, NULL, ecran, &positionFond);

        SDL_FreeSurface(saisie);
        saisie = TTF_RenderText_Blended(ggpolice, serie, noir);

        SDL_BlitSurface(saisie, NULL, ecran, &positionSaisie);
        SDL_Flip(ecran);
    }

    SDL_FreeSurface(fond);

    if(strlen(serie) != 0)
    {
        sprintf(chaine, "resultats/%s.txt", serie);
        fichier = fopen(chaine, "w");

        sprintf(chaine, "Srie : %s\n", serie);
        fputs(chaine, fichier);
        fputs("Rat\tPassages Sud\tChrono Sud\tPassages Nord\tChrono Nord\tPassages Ouest\tChrono Ouest\tPassages Est\tChrono Est\tPassages Centre\tChrono Centre\n", fichier);

        // Passages --
        Passage[0] = TTF_RenderText_Blended(police, "0", noir); // Exterieur
        positionPassage[0].x = 289 + 5;
        positionPassage[0].y = 432;

        Passage[1] = TTF_RenderText_Blended(police, "0", noir); // Objet 1
        positionPassage[1].x = 192 + 5;
        positionPassage[1].y = 51;

        Passage[2] = TTF_RenderText_Blended(ppolice, "0", noir); // Objet 2
        positionPassage[2].x = 50 + 5;
        positionPassage[2].y = 193;

        Passage[3] = TTF_RenderText_Blended(ppolice, "0", noir); // Objet 3
        positionPassage[3].x = 430 + 5;
        positionPassage[3].y = 293;

        Passage[4] = TTF_RenderText_Blended(ppolice, "0", noir); // Objet 4
        positionPassage[4].x = 240 + 5 + 18;
        positionPassage[4].y = 293;

        Passage[5] = TTF_RenderText_Blended(ppolice, "0", noir); // Centre 5
        positionPassage[5].x = 240 + 5 + 18;
        positionPassage[5].y = 293;

        // Chronos --
        Chrono[0] = TTF_RenderText_Blended(gpolice, "0:00", noir);
        positionChrono[0].x = 330 + 18;
        positionChrono[0].y = 431;

        Chrono[1] = TTF_RenderText_Blended(gpolice, "0:00", noir);
        positionChrono[1].x = 87 + 18;
        positionChrono[1].y = 50;

        Chrono[2] = TTF_RenderText_Blended(gpolice, "0:00", noir);
        positionChrono[2].x = 87 + 18;
        positionChrono[2].y = 194;

        Chrono[3] = TTF_RenderText_Blended(gpolice, "0:00", noir);
        positionChrono[3].x = 328 + 18;
        positionChrono[3].y = 287;

        Chrono[4] = TTF_RenderText_Blended(gpolice, "0:00", noir);
        positionChrono[4].x = 126 + 18;
        positionChrono[4].y = 287;

        Chrono[5] = TTF_RenderText_Blended(gpolice, "0:00", noir);
        positionChrono[5].x = 126 + 18;
        positionChrono[5].y = 287;

        convertir(chronometre, decompte);
        ChronoP = TTF_RenderText_Blended(ggpolice, chronometre, noir);
        positionChronoP.x = 18 + 27;
        positionChronoP.y = 452;

        fond = SDL_LoadBMP("fond II.bmp");
        bouton = IMG_Load("bouton.png");
        srat = IMG_Load("rat.png");

        // Point rouge --
        point = IMG_Load("point.png");

        positionPoint[0].x = 245;
        positionPoint[0].y = 414;

        positionPoint[1].x = 245;
        positionPoint[1].y = 77;

        positionPoint[2].x = 75;
        positionPoint[2].y = 246;

        positionPoint[3].x = 417;
        positionPoint[3].y = 246;

        positionPoint[4].x = 246;
        positionPoint[4].y = 246;

        positionPoint[5].x = 246;
        positionPoint[5].y = 246;

        // Positions --
        positionFond.x = 0;
        positionFond.y = 0;

        positionSaisie.x = 25;
        positionSaisie.y = 335;

        positionSarat.x = 180;
        positionSarat.y = 480;

        continuer = 1;
        while (continuer)
        {
            if(r == 0)
            {
                SDL_PollEvent(&event);
                switch(event.type)
                {
                    case SDL_QUIT:
                        continuer = 0;
                        break;
                    case SDL_KEYDOWN:
                        switch (event.key.keysym.sym)
                        {
                            case SDLK_ESCAPE: // Appui sur la touche Echap : arrt du programme
                                continuer = 0;
                                break;
                            case SDLK_SPACE:
                                if(top == 0)
                                {
                                    top = SDL_GetTicks();
                                    tempsPrecedent = SDL_GetTicks();
                                }
                                break;
                            case SDLK_RETURN:
                                if(p != 0 && top != 0)
                                {
                                    p = 0;
                                    passages[0]++;
                                }
                                break;
                            case SDLK_1:
                                if(p != 1 && top != 0)
                                {
                                    if(p != 0)
                                    {
                                        passages[0]++;
                                    }
                                    p = 1;
                                    passages[1]++;
                                }
                                break;
                            case SDLK_2:
                                if(p != 2 && top != 0)
                                {
                                    if(p != 0)
                                    {
                                        passages[0]++;
                                    }
                                    p = 2;
                                    passages[2]++;
                                }
                                break;
                            case SDLK_3:
                                if(p != 3 && top != 0)
                                {
                                    if(p != 0)
                                    {
                                        passages[0]++;
                                    }
                                    p = 3;
                                    passages[3]++;
                                }
                                break;
                            case SDLK_4:
                                if(p != 4 && top != 0)
                                {
                                    if(p != 0)
                                    {
                                        passages[0]++;
                                    }
                                    p = 4;
                                    passages[4]++;
                                }
                                break;
                            case SDLK_5:
                                if(p != 5 && top != 0)
                                {
                                    if(p != 0)
                                    {
                                        passages[0]++;
                                    }
                                    p = 5;
                                    passages[5]++;
                                }
                                break;
                        }
                        break;
                }
            }
            else
            {
                SDL_WaitEvent(&event);
                continuer = clavier(event, rat, 14);
                if(strlen(rat) != 0 && continuer == 0)
                {
                    continuer = 1;
                    r = 0;
                    sprintf(arat, "%s", rat);
                    sprintf(rat, "");

                    for(i = 0; i < 5; i++)
                    {
                        chronos[i] = 0;
                        Chrono[i] = TTF_RenderText_Blended(gpolice, "0:00", noir);
                        decompte = 5 * 60 * 1000;
                        passages[i] = 0;
                        p = 4;
                    }
                }
            }

            for(i = 0; i < 5; i++)
            {
                SDL_FreeSurface(Passage[i]);
            }

            // Passages --
            for(i = 0; i < 2; i++) // Indicateurs horizontaux --
            {
                sprintf(cpassage, "%d", passages[i]);
                Passage[i] = TTF_RenderText_Blended(police, cpassage, noir);
                if(passages[i] > 9)
                {
                    centrage[i] = 0;
                }
                else
                {
                    centrage[i] = 5;
                }
            }

            for(i = 2; i < 5; i++) // Indicateurs verticaux --
            {
                sprintf(cpassage, "%d", passages[i]);
                Passage[i] = TTF_RenderText_Blended(ppolice, cpassage, noir);
                if(passages[i] > 9)
                {
                    centrage[i] = 0;
                }
                else
                {
                    centrage[i] = 5;
                }
            }

            positionPassage[0].x = 289 + centrage[0];
            positionPassage[0].y = 432;

            positionPassage[1].x = 192 + centrage[1];
            positionPassage[1].y = 51;

            positionPassage[2].x = 50 + centrage[2];
            positionPassage[2].y = 193;

            positionPassage[3].x = 430 + centrage[3];
            positionPassage[3].y = 293;

            positionPassage[4].x = 240 + centrage[4];
            positionPassage[4].y = 293;

            tempsActuel = SDL_GetTicks();
            if (tempsActuel - tempsPrecedent > delais[1] && top != 0)
            {
                int temps = tempsActuel - tempsPrecedent, test = decompte;

                test -= temps;
                if(test < 0)
                {
                    temps = decompte;
                    decompte = 0;
                    top = 0;
                    r = 1;
                }
                else
                {
                    decompte -= temps;
                }
                chronos[p] += temps;

                SDL_FreeSurface(ChronoP);
                convertir(chronometre, decompte);
                ChronoP = TTF_RenderText_Blended(ggpolice, chronometre, noir);

                SDL_FreeSurface(Chrono[p]);
                convertir(chronometre, chronos[p]);
                Chrono[p] = TTF_RenderText_Blended(gpolice, chronometre, noir);
                tempsPrecedent = tempsActuel;

                if(top == 0)
                {
                    if (fichier != NULL)
                    {
                        double fchronos[5];

                        for(i = 0; i < 5; i++)
                        {
                            fchronos[i] = chronos[i];
                            fchronos[i] /= 1000;
                        }

                        sprintf(chaine, "%s\t%d\t%f\t%d\t%f\t%d\t%f\t%d\t%f\t%d\t%f\n", rat, passages[0], fchronos[0], passages[1], fchronos[1], passages[2], fchronos[2], passages[3], fchronos[3], passages[4], fchronos[4]);
                        fputs(chaine, fichier);

                    }
                }
            }

            SDL_BlitSurface(fond, NULL, ecran, &positionFond);

            for(i = 0; i < 5; i++)
            {
                SDL_BlitSurface(Passage[i], NULL, ecran, &positionPassage[i]);
                SDL_BlitSurface(Chrono[i], NULL, ecran, &positionChrono[i]);
            }

            SDL_BlitSurface(ChronoP, NULL, ecran, &positionChronoP);

            if(top == 0)
            {
                if(r == 1)
                {
                    SDL_BlitSurface(srat, NULL, ecran, &positionFond);
                    SDL_FreeSurface(saisie);
                    saisie = TTF_RenderText_Blended(police, rat, noir);
                    SDL_BlitSurface(saisie, NULL, ecran, &positionSaisie);
                }
                else
                {
                    SDL_BlitSurface(bouton, NULL, ecran, &positionFond);
                }
            }

            SDL_FreeSurface(sarat);
            sarat = TTF_RenderText_Blended(police, arat, noir);
            SDL_BlitSurface(sarat, NULL, ecran, &positionSarat);

            SDL_BlitSurface(point, NULL, ecran, &positionPoint[p]);

            SDL_Flip(ecran);
            if(delais[0] != 0)
            {
                SDL_Delay(delais[0]);
            }
        }

        // Libration de la mmoire --

        for(i = 0; i < 5; i++)
        {
            SDL_FreeSurface(Passage[i]);
            SDL_FreeSurface(Chrono[i]);
        }

        SDL_FreeSurface(ChronoP);

        SDL_FreeSurface(fond);
        SDL_FreeSurface(bouton);
        SDL_FreeSurface(saisie);
        SDL_FreeSurface(srat);
        SDL_FreeSurface(point);
        SDL_FreeSurface(sarat);
    }

    SDL_FreeSurface(ecran);
    SDL_Quit();

    TTF_CloseFont(ppolice);
    TTF_CloseFont(police);
    TTF_CloseFont(gpolice);
    TTF_CloseFont(ggpolice);
    TTF_Quit();

    if(fichier != NULL)
    {
        fclose(fichier);
    }

    return 0;
}

void convertir(char* chaine, const int temps)
{
    int minutes, secondes;
    char cmin[100] = "00", csec[100] = "", cmilli[100] = "00";

    minutes = floor(temps / 60000);
    sprintf(cmin, "%d", minutes);

    secondes = floor((temps % 60000)/ 1000);
    if(secondes < 10)
    {
        sprintf(csec, "0%d", secondes);
    }
    else
    {
        sprintf(csec, "%d", secondes);
    }
    sprintf(chaine, "%s:%s", cmin, csec);
}

int clavier(SDL_Event event, char* saisie, int max)
{
    int continuer = 1;

    switch(event.type)
    {
        case SDL_QUIT:
        continuer = 0;
        sprintf(saisie, "");
        break;
        case SDL_KEYDOWN:
        if(strlen(saisie) <= max)
        {
            switch(event.key.keysym.sym)
            {
                case SDLK_SPACE:
                strcat(saisie, " ");
                continuer = 1;
                break;
                case SDLK_ESCAPE:
                continuer = 0;
                sprintf(saisie, "");
                break;
                case SDLK_a:
                strcat(saisie, "Q");
                continuer = 1;
                break;
                case SDLK_b:
                strcat(saisie, "B");
                continuer = 1;
                break;
                case SDLK_c:
                strcat(saisie, "C");
                continuer = 1;
                break;
                case SDLK_d:
                strcat(saisie, "D");
                continuer = 1;
                break;
                case SDLK_e:
                strcat(saisie, "E");
                continuer = 1;
                break;
                case SDLK_f:
                strcat(saisie, "F");
                continuer = 1;
                break;
                case SDLK_g:
                strcat(saisie, "G");
                continuer = 1;
                break;
                case SDLK_h:
                strcat(saisie, "H");
                continuer = 1;
                break;
                case SDLK_i:
                strcat(saisie, "I");
                continuer = 1;
                break;
                case SDLK_j:
                strcat(saisie, "J");
                continuer = 1;
                break;
                case SDLK_k:
                strcat(saisie, "K");
                continuer = 1;
                break;
                case SDLK_l:
                strcat(saisie, "L");
                continuer = 1;
                break;
                case SDLK_SEMICOLON:
                strcat(saisie, "M");
                continuer = 1;
                break;
                case SDLK_n:
                strcat(saisie, "N");
                continuer = 1;
                break;
                case SDLK_o:
                strcat(saisie, "O");
                continuer = 1;
                break;
                case SDLK_p:
                strcat(saisie, "P");
                continuer = 1;
                break;
                case SDLK_q:
                strcat(saisie, "A");
                continuer = 1;
                break;
                case SDLK_r:
                strcat(saisie, "R");
                continuer = 1;
                break;
                case SDLK_s:
                strcat(saisie, "S");
                continuer = 1;
                break;
                case SDLK_t:
                strcat(saisie, "T");
                continuer = 1;
                break;
                case SDLK_u:
                strcat(saisie, "U");
                continuer = 1;
                break;
                case SDLK_v:
                strcat(saisie, "V");
                continuer = 1;
                break;
                case SDLK_w:
                strcat(saisie, "Z");
                continuer = 1;
                break;
                case SDLK_x:
                strcat(saisie, "X");
                continuer = 1;
                break;
                case SDLK_y:
                strcat(saisie, "Y");
                continuer = 1;
                break;
                case SDLK_z:
                strcat(saisie, "W");
                continuer = 1;
                break;

                case SDLK_0:
                strcat(saisie, "0");
                continuer = 1;
                break;
                case SDLK_1:
                strcat(saisie, "1");
                continuer = 1;
                break;
                case SDLK_2:
                strcat(saisie, "2");
                continuer = 1;
                break;
                case SDLK_3:
                strcat(saisie, "3");
                continuer = 1;
                break;
                case SDLK_4:
                strcat(saisie, "4");
                continuer = 1;
                break;
                case SDLK_5:
                strcat(saisie, "5");
                continuer = 1;
                break;
                case SDLK_6:
                strcat(saisie, "6");
                continuer = 1;
                break;
                case SDLK_7:
                strcat(saisie, "7");
                continuer = 1;
                break;
                case SDLK_8:
                strcat(saisie, "8");
                continuer = 1;
                break;
                case SDLK_9:
                strcat(saisie, "9");
                continuer = 1;
                break;
                case SDLK_RETURN:
                if(strlen(saisie) != 0)
                {
                    continuer = 0;
                }
                break;
                case SDLK_DELETE:
                sprintf(saisie, "");
                break;
            }
        }
        else
        {
            switch(event.key.keysym.sym)
            {
                case SDLK_ESCAPE:
                continuer = 0;
                sprintf(saisie, "");
                break;
                case SDLK_RETURN:
                if(strlen(saisie) != 0)
                {
                    continuer = 0;
                }
                break;
                case SDLK_DELETE:
                sprintf(saisie, "");
                break;
            }
        }
        break;
    }
    return continuer;
}
